""" Consensus Package """


import numpy as np
from mpi4py import MPI

comm = MPI.COMM_WORLD
size = MPI.COMM_WORLD.Get_size()
rank = MPI.COMM_WORLD.Get_rank()


class Consensus:

    def __init__(self, peer, weight):
        self.weight = weight
        self.peer = peer

    # def send_to_neighbors(self, x):
    #     for i in self.peer:
    #         comm.Isend(x, dest=i, tag=rank)
    #
    # def collect_from_neighbors(self, x):
    #     x = x * self.weight[rank]
    #     wait_time_start = MPI.Wtime()
    #     while True:
    #         for i in self.peer:
    #             recvbuf = np.empty(x.shape, dtype=np.float64)
    #             req = comm.Irecv(recvbuf, source=i)
    #             req.wait()
    #             x += self.weight[i] * recvbuf
    #             # del status
    #         return x
    #         if MPI.Wtime() - wait_time_start > hold_on_time:
    #             warnings('wait too long for recieving, may deadlock...')

    def send_to_neighbors(self, x):
        for i in self.peer:
            comm.Send(x, dest = i, tag = rank)
  
    def collect_from_neighbors(self, x):
        x = x * self.weight[rank]
        # wait_time_start = MPI.Wtime()
        while True:
            for i in self.peer:
                # status = MPI.Status()
                # while not comm.Probe(source=MPI.ANY_SOURCE, status=status):
                #     pass
                recvbuf = np.empty(x.shape, dtype = np.float64)
                comm.Recv(recvbuf, source = i)
                x += self.weight[i] * recvbuf
                # del status
            return x
            # if MPI.Wtime() - wait_time_start > hold_on_time:
            #     warnings('wait too long for recieving, may deadlock...')

    def communication(self, x, consensus_step):
        for _ in range(consensus_step):
            self.send_to_neighbors(x)
            x = self.collect_from_neighbors(x)
            comm.Barrier()
        return x